ARM: dts: clearfog: fix sdhci supply property name
[linux-2.6-block.git] / scripts / link-vmlinux.sh
CommitLineData
1f2bfbd0 1#!/bin/sh
b2441318 2# SPDX-License-Identifier: GPL-2.0
1f2bfbd0
SR
3#
4# link vmlinux
5#
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
f49821ee 7# $(KBUILD_VMLINUX_MAIN) and $(KBUILD_VMLINUX_LIBS). Most are built-in.a files
3a166fc2
NP
8# from top-level directories in the kernel tree, others are specified in
9# arch/$(ARCH)/Makefile. Ordering when linking is important, and
10# $(KBUILD_VMLINUX_INIT) must be first. $(KBUILD_VMLINUX_LIBS) are archives
11# which are linked conditionally (not within --whole-archive), and do not
12# require symbol indexes added.
1f2bfbd0
SR
13#
14# vmlinux
15# ^
16# |
17# +-< $(KBUILD_VMLINUX_INIT)
18# | +--< init/version.o + more
19# |
20# +--< $(KBUILD_VMLINUX_MAIN)
f49821ee 21# | +--< drivers/built-in.a mm/built-in.a + more
1f2bfbd0 22# |
3a166fc2
NP
23# +--< $(KBUILD_VMLINUX_LIBS)
24# | +--< lib/lib.a + more
25# |
1f2bfbd0
SR
26# +-< ${kallsymso} (see description in KALLSYMS section)
27#
28# vmlinux version (uname -v) cannot be updated during normal
29# descending-into-subdirs phase since we do not yet know if we need to
30# update vmlinux.
31# Therefore this step is delayed until just before final link of vmlinux.
32#
33# System.map is generated to document addresses of all kernel symbols
34
35# Error out on error
36set -e
37
38# Nice output in kbuild format
39# Will be supressed by "make -s"
40info()
41{
42 if [ "${quiet}" != "silent_" ]; then
43 printf " %-7s %s\n" ${1} ${2}
44 fi
45}
46
3a166fc2
NP
47# Thin archive build here makes a final archive with symbol table and indexes
48# from vmlinux objects INIT and MAIN, which can be used as input to linker.
49# KBUILD_VMLINUX_LIBS archives should already have symbol table and indexes
50# added.
a5967db9
SR
51#
52# Traditional incremental style of link does not require this step
53#
f49821ee 54# built-in.a output file
a5967db9
SR
55#
56archive_builtin()
57{
f49821ee
NP
58 info AR built-in.a
59 rm -f built-in.a;
60 ${AR} rcsTP${KBUILD_ARFLAGS} built-in.a \
6358d6e8
NP
61 ${KBUILD_VMLINUX_INIT} \
62 ${KBUILD_VMLINUX_MAIN}
a5967db9
SR
63}
64
1f2bfbd0
SR
65# Link of vmlinux.o used for section mismatch analysis
66# ${1} output file
67modpost_link()
68{
a5967db9
SR
69 local objects
70
6358d6e8 71 objects="--whole-archive \
f49821ee 72 built-in.a \
6358d6e8
NP
73 --no-whole-archive \
74 --start-group \
75 ${KBUILD_VMLINUX_LIBS} \
76 --end-group"
77
d503ac53 78 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
1f2bfbd0
SR
79}
80
81# Link of vmlinux
82# ${1} - optional extra .o files
83# ${2} - output file
84vmlinux_link()
85{
86 local lds="${objtree}/${KBUILD_LDS}"
a5967db9 87 local objects
1f2bfbd0
SR
88
89 if [ "${SRCARCH}" != "um" ]; then
6358d6e8 90 objects="--whole-archive \
f49821ee 91 built-in.a \
6358d6e8
NP
92 --no-whole-archive \
93 --start-group \
94 ${KBUILD_VMLINUX_LIBS} \
95 --end-group \
96 ${1}"
a5967db9 97
d503ac53 98 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \
a5967db9 99 -T ${lds} ${objects}
1f2bfbd0 100 else
6358d6e8 101 objects="-Wl,--whole-archive \
f49821ee 102 built-in.a \
6358d6e8
NP
103 -Wl,--no-whole-archive \
104 -Wl,--start-group \
105 ${KBUILD_VMLINUX_LIBS} \
106 -Wl,--end-group \
107 ${1}"
a5967db9 108
6358d6e8
NP
109 ${CC} ${CFLAGS_vmlinux} -o ${2} \
110 -Wl,-T,${lds} \
111 ${objects} \
a5967db9 112 -lutil -lrt -lpthread
1f2bfbd0
SR
113 rm -f linux
114 fi
115}
116
117
118# Create ${2} .o file with all symbols from the ${1} object file
119kallsyms()
120{
121 info KSYM ${2}
122 local kallsymopt;
123
124 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
6895f97e 125 kallsymopt="${kallsymopt} --all-symbols"
1f2bfbd0
SR
126 fi
127
4d5d5664 128 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
c6bda7c9
RR
129 kallsymopt="${kallsymopt} --absolute-percpu"
130 fi
131
2213e9a6
AB
132 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
133 kallsymopt="${kallsymopt} --base-relative"
134 fi
135
00e6c28c
SR
136 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
137 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
1f2bfbd0 138
a0439342
AB
139 local afile="`basename ${2} .o`.S"
140
141 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
142 ${CC} ${aflags} -c -o ${2} ${afile}
1f2bfbd0
SR
143}
144
145# Create map file with all symbols from ${1}
146# See mksymap for additional details
147mksysmap()
148{
149 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
150}
151
1347a2ce
LT
152sortextable()
153{
154 ${objtree}/scripts/sortextable ${1}
155}
156
1f2bfbd0 157# Delete output files in case of error
1f2bfbd0
SR
158cleanup()
159{
1f2bfbd0
SR
160 rm -f .tmp_System.map
161 rm -f .tmp_kallsyms*
1f2bfbd0 162 rm -f .tmp_vmlinux*
f49821ee 163 rm -f built-in.a
1f2bfbd0
SR
164 rm -f System.map
165 rm -f vmlinux
166 rm -f vmlinux.o
167}
168
ab160dbb
SB
169on_exit()
170{
171 if [ $? -ne 0 ]; then
172 cleanup
173 fi
174}
175trap on_exit EXIT
176
177on_signals()
178{
179 exit 1
180}
181trap on_signals HUP INT QUIT TERM
182
1f2bfbd0
SR
183#
184#
185# Use "make V=1" to debug this script
186case "${KBUILD_VERBOSE}" in
187*1*)
188 set -x
189 ;;
190esac
191
192if [ "$1" = "clean" ]; then
193 cleanup
194 exit 0
195fi
196
197# We need access to CONFIG_ symbols
423a8155
MM
198case "${KCONFIG_CONFIG}" in
199*/*)
200 . "${KCONFIG_CONFIG}"
201 ;;
202*)
203 # Force using a file from the current directory
204 . "./${KCONFIG_CONFIG}"
205esac
1f2bfbd0 206
1f2bfbd0
SR
207# Update version
208info GEN .version
278ae604
MY
209if [ -r .version ]; then
210 VERSION=$(expr 0$(cat .version) + 1)
211 echo $VERSION > .version
1f2bfbd0 212else
278ae604
MY
213 rm -f .version
214 echo 1 > .version
1f2bfbd0
SR
215fi;
216
217# final build of init/
a7b151ff 218${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
1f2bfbd0 219
abac4c89
NP
220archive_builtin
221
222#link vmlinux.o
223info LD vmlinux.o
224modpost_link vmlinux.o
225
226# modpost vmlinux.o to check for section mismatches
227${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
228
1f2bfbd0
SR
229kallsymso=""
230kallsyms_vmlinux=""
231if [ -n "${CONFIG_KALLSYMS}" ]; then
232
233 # kallsyms support
234 # Generate section listing all symbols and add it into vmlinux
235 # It's a three step process:
236 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
237 # but __kallsyms is empty.
238 # Running kallsyms on that gives us .tmp_kallsyms1.o with
239 # the right size
240 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
241 # the right size, but due to the added section, some
242 # addresses have shifted.
243 # From here, we generate a correct .tmp_kallsyms2.o
7e2b37c9
NP
244 # 3) That link may have expanded the kernel image enough that
245 # more linker branch stubs / trampolines had to be added, which
246 # introduces new names, which further expands kallsyms. Do another
247 # pass if that is the case. In theory it's possible this results
248 # in even more stubs, but unlikely.
249 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
250 # other bugs.
251 # 4) The correct ${kallsymso} is linked into the final vmlinux.
1f2bfbd0
SR
252 #
253 # a) Verify that the System.map from vmlinux matches the map from
254 # ${kallsymso}.
255
256 kallsymso=.tmp_kallsyms2.o
257 kallsyms_vmlinux=.tmp_vmlinux2
258
259 # step 1
260 vmlinux_link "" .tmp_vmlinux1
261 kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
262
263 # step 2
264 vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
265 kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
266
7e2b37c9 267 # step 3
a670b0b4
MF
268 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms1.o)
269 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms2.o)
7e2b37c9
NP
270
271 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
1f2bfbd0
SR
272 kallsymso=.tmp_kallsyms3.o
273 kallsyms_vmlinux=.tmp_vmlinux3
274
275 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
276
277 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
278 fi
279fi
280
281info LD vmlinux
282vmlinux_link "${kallsymso}" vmlinux
283
1347a2ce
LT
284if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
285 info SORTEX vmlinux
286 sortextable vmlinux
287fi
288
1f2bfbd0
SR
289info SYSMAP System.map
290mksysmap vmlinux System.map
291
292# step a (see comment above)
293if [ -n "${CONFIG_KALLSYMS}" ]; then
294 mksysmap ${kallsyms_vmlinux} .tmp_System.map
295
296 if ! cmp -s System.map .tmp_System.map; then
5369f550 297 echo >&2 Inconsistent kallsyms data
367e43c5 298 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
1f2bfbd0
SR
299 exit 1
300 fi
301fi